'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Avatar = require('./Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AvatarUploader = function (_Component) {
    _inherits(AvatarUploader, _Component);

    function AvatarUploader(props) {
        _classCallCheck(this, AvatarUploader);

        var _this = _possibleConstructorReturn(this, (AvatarUploader.__proto__ || Object.getPrototypeOf(AvatarUploader)).call(this, props));

        _this.state = {
            currentImage: null,
            loading: false
        };

        _this.uploadImage = _this.uploadImage.bind(_this);
        _this.onImageChange = _this.onImageChange.bind(_this);
        return _this;
    }

    _createClass(AvatarUploader, [{
        key: 'uploadImage',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(avatar) {
                var _props, uploadURL, onFinished, formDataName, avatarForm, res;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _props = this.props, uploadURL = _props.uploadURL, onFinished = _props.onFinished, formDataName = _props.formDataName;

                                if (!uploadURL) {
                                    _context.next = 21;
                                    break;
                                }

                                _context.prev = 2;

                                this.setState({ loading: true });
                                avatarForm = new FormData();


                                avatarForm.append(formDataName, avatar, avatar.name);

                                _context.next = 8;
                                return fetch(uploadURL, {
                                    method: 'POST',
                                    credentials: 'include',
                                    body: avatarForm
                                });

                            case 8:
                                res = _context.sent;

                                if (!(res.status && res.status === 200)) {
                                    _context.next = 15;
                                    break;
                                }

                                _context.next = 12;
                                return res.json();

                            case 12:
                                res = _context.sent;

                                this.setState({ currentImage: res, loading: false });

                                if (onFinished && typeof onFinished === 'function') {
                                    onFinished(false, res);
                                }

                            case 15:
                                _context.next = 21;
                                break;

                            case 17:
                                _context.prev = 17;
                                _context.t0 = _context['catch'](2);

                                this.setState({ loading: false });
                                if (onFinished && typeof onFinished === 'function') {
                                    onFinished(_context.t0);
                                }

                            case 21:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[2, 17]]);
            }));

            function uploadImage(_x) {
                return _ref.apply(this, arguments);
            }

            return uploadImage;
        }()
    }, {
        key: 'onImageChange',
        value: function onImageChange(e) {
            var _this2 = this;

            var imageToUpload = e.target.files[0];
            var reader = new FileReader();
            reader.onload = function (avatar) {
                return _this2.setState({ currentImage: avatar.target.result });
            };
            reader.readAsDataURL(imageToUpload);

            this.uploadImage(imageToUpload);
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                disabled = _props2.disabled,
                size = _props2.size,
                defaultImg = _props2.defaultImg,
                fileType = _props2.fileType;
            var currentImage = this.state.currentImage;

            return _react2.default.createElement(
                _Avatar2.default,
                { size: size },
                currentImage || defaultImg ? _react2.default.createElement(_Avatar2.default.Preview, { src: currentImage || defaultImg }) : _react2.default.createElement(_Avatar2.default.Uploader, {
                    fileType: fileType,
                    onChange: this.onImageChange,
                    disabled: disabled })
            );
        }
    }]);

    return AvatarUploader;
}(_react.Component);

exports.default = AvatarUploader;


AvatarUploader.propTypes = {
    uploadURL: _propTypes2.default.string.isRequired,
    onFinished: _propTypes2.default.func,
    disabled: _propTypes2.default.bool,
    fileType: _propTypes2.default.string,
    size: _propTypes2.default.number,
    defaultImg: _propTypes2.default.string,
    formDataName: _propTypes2.default.string
};